#define _POSIX_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/shm.h>

struct shared_content {
    bool permission;
    char text[2048];
};

int main(){
	void *shared_memory = (void *)0;
	struct shared_content *shared_content;
	bool reading = true;
	char buffer[BUFSIZ];

	//Vytvorenie zdieľanej pamäte:
	int shm_id = [2......](1234,sizeof(struct shared_content),0666 | IPC_CREAT);
	//V prípade chyby:
	if(shm_id==-1){
		exit(1);
	}

	//Pripojenie zdieľanej pamäte:
	shared_memory = [4.....](shm_id, (void *)0, 0);
	if(shared_memory == (void *)-1) {
		//V prípade chyby:
		exit(1);
	}

	//printf("Smernik na prvy bajt zdielanej pamate: %X.\n", (int)shared_memory);

	shared_content = (struct shared_content*) shared_memory;

	while(reading){
		while(shared_content->permission){
			sleep(1);
			printf("Cakanie na precitanie obsahu...\n");
		}
		printf("Vloz nejaky text: ");
		fgets(buffer, BUFSIZ, stdin);
		strncpy(shared_content->text, buffer, 2048);
		shared_content->permission = true;
		if (strncmp(buffer, "end", 3) == 0) {
			reading = false; //Ak používateľ zadá reťazec "end" tak sa ukončí vykonávanie a zdieľaná pamäť sa odpojí.   
	   	}
	}

	//Odpojenie zdieľanej pamäte:
	if([5.....](shared_memory) == -1) {
		//V prípade chyby:
		exit(1);
	}
	else{
		printf("Zdielana pamat bola odpojena.\n");
	}
	exit(0);
}